/*
 * 3D Engine 
 * texture.h: 
 * Based on pikuma.com 3D software renderer in C
 * Copyright (c) 2021 986-Studio. All rights reserved.
 *
 * Created by Manoël Trapier on 07/03/2021.
 */

#ifndef THREEDENGINE_SOURCE_INCLUDE_TEXTURE_H
#define THREEDENGINE_SOURCE_INCLUDE_TEXTURE_H

#include <stdint.h>

#include <upng.h>

#include <display.h>

/***********************************************************************************************************************
 * Data types
 **********************************************************************************************************************/
typedef struct tex2_t
{
    double u, v;
} tex2_t;

/***********************************************************************************************************************
 * Global variables
 **********************************************************************************************************************/
extern int textureWidth;
extern int textureHeight;

extern const uint8_t REDBRICK_TEXTURE[];

colour_t *meshTexture;
extern upng_t *pngTexture;

/***********************************************************************************************************************
 * Prototypes
 **********************************************************************************************************************/
void loadTextureDateFromPng(const char *filepath);
void textureCleanup();

#endif /* THREEDENGINE_SOURCE_INCLUDE_TEXTURE_H */
